<script setup lang="ts">
	import { showToast } from 'vant';
	import { onMounted, ref, watch } from 'vue';
	import { getAction } from '../../common/http';
	import { formatDate } from '../../utils/date';
	import { onShow } from '@dcloudio/uni-app';

	const form = ref({} as any)
	const list = ref([] as any[])
	const colorList = ref([] as any[])
	const nameList = ref([] as any[])
	
	const statusList = ref([
		{ status: "待审核", code: "UnCheck", type: "warning",path:'/pages/spot/audit' },
		{ status: "已通过", code: "Checked", type: "primary",path:'/pages/spot/pass' },
		{ status: "已驳回", code: "Canceled", type: "danger" },
	])
	
	onMounted(() => {
		getAction('/fabric/info/all').then((res : any) => {
			if (res.code === 200) {
				res.data.forEach((l : any) => {
					let itemMl = mlList.value.find(m => m.text === l.commodity)
					if (itemMl) {
						let itemMm = itemMl.children.find(m => m.value === l.momme)
						if (itemMm) {
							itemMm.children.push({ text: l.width + 'cm', value: l.width })
						} else {
							itemMl.children.push({
								text: l.momme + 'mm',
								value: l.momme,
								children: [{ text: l.width + 'cm', value: l.width }]
							})
						}
					} else {
						mlList.value.push({
							text: l.commodity,
							value: l.commodity,
							children: [{ text: l.momme + 'mm', value: l.momme, children: [{ text: l.width + 'cm', value: l.width }] }]
						})
					}
				})
			}
		})
		getAction('/color/list').then((res : any) => {
			if (res.code === 200) {
				colorList.value = res.data.map((l : any) => ({ value: l.colorCode + l.colorName, text: l.colorCode + l.colorName }))
			}
		})
		getAction('/v1/user/getNames').then((res : any) => {
			if (res.code === 200) {
				nameList.value = res.data.map((l : any) => ({ value: l, text: l }))
			}
		})
	})
	onShow(()=>{
		list.value = []
		init()
	})

	const onClickLeft = () => {
		history.back()
	}
	const onClickRight = () => {
		uni.navigateTo({
			url: '/pages/spot/spot'
		})
	}

	watch(form.value, () => {
		list.value = []
		init()
	})

	const total = ref(0)
	const currentPage = ref(1)
	const finished = ref(false)
	const loading = ref(false);

	//动态获取数据
	const onLoad = () => {
		if (list.value.length < total.value) {
			currentPage.value++
			init()
		} else {
			finished.value = true
		}
	};

	function init() {
		getAction('/interOrder', { page: currentPage.value, size: 10, ...form.value }).then((res : any) => {
			if (res.code === 200) {
				res.data.record.forEach((l : any) => {
					list.value.push(l)
					let item =statusList.value.find((m:any)=>m.status==l.status)
					l.statusColor=item.type
					
				})
				total.value = res.data.total
				loading.value = false;
				finished.value = false
			}
		})
	}



	const pickerList = ref([])//面料数据
	const pickerContainerList = ref([])
	const showPickerList = ref(false)
	const searchValue = ref('')//查询的值
	const searchIndex = ref(0)//查询到的数组
	const mlList = ref([])
	//选择面料
	const selectChoose = () => {
		showPickerList.value = true
	}
	//面料开启
	const mlmcOpen = () => {
		pickerList.value = mlList.value
		pickerContainerList.value = pickerList.value
		searchValue.value = ''
	}
	//面料关闭
	const pickerCancel = () => {
		showPickerList.value = false
	}

	//搜索
	const selectedValue = ref()
	const getSeachList = () => {
		searchIndex.value = 0
		let reg = new RegExp(searchValue.value)
		let arr = []
		pickerList.value.forEach(l => {
			if (reg.test(l.text)) {
				arr.push(l)
			}
		})
		pickerContainerList.value = arr
	}
	//向上选择
	const upSearch = () => {
		if (searchIndex.value === 0 && pickerContainerList.value.length) {
			searchIndex.value = pickerContainerList.value.length - 1
			selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
		} else if (pickerContainerList.value.length) {
			searchIndex.value--
			selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
		} else {
			showToast('没有了！')
		}
	}
	//向下选择
	const downSearch = () => {
		if (pickerContainerList.value.length) {
			if (searchIndex.value === pickerContainerList.value.length) {
				searchIndex.value = 0
				selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
			} else {
				searchIndex.value++
				selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
			}
		} else {
			showToast('没有了！')
		}
	}
	//搜索框输入
	const timer = ref()
	const searchTo = () => {
		if (timer.value) {
			clearTimeout(timer.value)
		}
		timer.value = setTimeout(() => {
			getSeachList()
		}, 800)
	}
	const onConfirm = (val : any) => {
		form.value.category = val.selectedValues[2] + '/' + val.selectedValues[0] + val.selectedValues[1]
		pickerCancel()
	}

	const showPicker = ref(false)
	const typeData = ref()
	const popuList = ref([] as any[])
	//选择框事件
	const choosePic = (type : any) => {
		showPicker.value = true
		typeData.value = type
	}
	//选择框确认
	const pickerConfirm = (val : any) => {
		form.value[typeData.value] = val.selectedValues[0]
		showPicker.value = false
	}
	//取消
	const showPickerCancel = () => {
		showPicker.value = false
		form.value[typeData.value] = ''
	}
	//弹窗开启事件
	const handleOpen = () => {
		if (typeData.value === 'color') {
			popuList.value = colorList.value
		} else if (typeData.value === 'status') {
			popuList.value = [
				{ text: "待审核", value: "待审核" },
				{ text: "待主管审核", value: "待主管审核" },
				{ text: "待跟单员审核", value: "待跟单员审核", },
				{ text: "已通过（待配货）", value: "已通过（待配货）" },
				{ text: "取消审核中", value: "取消审核中" },
				{ text: "已取消", value: "已取消" },
				{ text: "被驳回", value: "被驳回" },
				{ text: "部分配货", value: "部分配货" },
				{ text: "已配完（待进厂）", value: "已配完（待进厂）", },
				{ text: "已进厂", value: "已进厂" },
				{ text: "已出厂（待收货）", value: "已出厂（待收货）", },
				{ text: "待质检", value: "待质检" },
				{ text: "已质检（待入库）", value: "已质检（待入库）" },
				{ text: "已质检（待入库）", value: "已质检（待入库）" },
				{ text: "已入库", value: "已入库", },
			]
		} else if (typeData.value === 'makeUser') {
			popuList.value = nameList.value
		}
	}
	//日期选择
	const show = ref(false)
	const dataType = ref('')
	const chooseDate = (val : any) => {
		show.value = true
		dataType.value = val
	}
	const onConfirmDate = (val : any) => {
		form.value[dataType.value] = formatDate(val)
		show.value = false
	}

	
	const gotoLink= (item:any) =>{
		let a = statusList.value.find((l : any) => l.status === item.status)
		let url=a.path+'?'+'item='+JSON.stringify(item)
		uni.navigateTo({
			url:url,
		})
	}
</script>

<template>
	<view class="flex">
		<van-nav-bar title="需求单列表" left-text="返回" left-arrow right-text="新增需求单" @click-left="onClickLeft"
			@click-right="onClickRight()" />
		<van-cell-group inset style="display: flex;">
			<van-field v-model="form.startDate" name="开始时间" label="开始时间" colon class="bor" label-width="5em" readonly
				@click="chooseDate('startDate')" :rules="[{ required: true, message: '请填写' }]" />
			<van-field v-model="form.endDate" name="截止时间" label="截止时间" colon class="bor" label-width="5em" readonly
				@click="chooseDate('endDate')" />
		</van-cell-group>
		<van-cell-group inset style="display: flex;">
			<!-- <van-field v-model="form.category" name="面料筛选" label="面料筛选" colon class="bor" label-width="5em" readonly
				@click="selectChoose" /> -->
			<van-field v-model="form.color" name="颜色筛选" label="颜色筛选" colon class="bor" label-width="5em" readonly
				@click="choosePic('color')" />
			<van-field v-model="form.status" name="订单状态" label="订单状态" colon class="bor" label-width="5em" readonly
				@click="choosePic('status')" />
		</van-cell-group>
		<van-cell-group inset style="display: flex;">
			<van-field v-model="form.makeUser" name="做单人员" label="做单人员" colon class="bor" label-width="5em" readonly
				@click="choosePic('makeUser')" />
		</van-cell-group>
		<view class="grid-container">
			<view class="grid-item">日期/颜色</view>
			<view class="grid-item">面料名称/工艺/谁定</view>
			<view class="grid-item">匹数</view>
			<view class="grid-item">操作</view>
		</view>
		<view class="content">
			<van-list v-model:loading="loading" :finished="finished" finished-text="没有更多了" @load="onLoad">
				<view class="grid-container" v-for="(item,index) in list" :key="index">
					<view class="grid-item">{{formatDate(item.makeTime)}}<br>{{item.color}}</view>
					<view class="grid-item">
						<view class="grid-container1">
							<view :class="indexSecond===(item.fabric.length-1)?'grid-item2':'grid-item1'"
								v-for="(itemSecond,indexSecond) in item.fabric" :key="indexSecond">
								{{itemSecond.name}}<br>{{item.craft}}&nbsp;&nbsp;&nbsp;{{itemSecond.belongTo}}
							</view>
						</view>
					</view>
					<view class="grid-item">
						<view class="grid-container1">
							<view :class="indexSecond===(item.fabric.length-1)?'grid-item2':'grid-item1'"
								v-for="(itemSecond,indexSecond) in item.fabric" :key="indexSecond">
								{{itemSecond.quantity}}
							</view>
						</view>
					</view>
					<view class="grid-item" @click="gotoLink(item)">
						<van-button :type="item.statusColor">{{item.status}}</van-button>
					</view>
				</view>
			</van-list>
		</view>
	</view>

	<!--选择框-->
	<van-popup v-model:show="showPicker" round position="bottom" @open="handleOpen">
		<van-picker show-toolbar :columns="popuList" @confirm="pickerConfirm" @cancel="showPickerCancel"
			ref="pickerRef" />
	</van-popup>

	<!--    面料选择框-->
	<van-popup v-model:show="showPickerList" position="bottom" @open="mlmcOpen">
		<view class="select-model">
			<van-picker :columns="pickerContainerList" @cancel="pickerCancel" v-model="selectedValue"
				@confirm="onConfirm" />
			<view>
				<view class="top-select">
					<view class="confirm-select">
						<p>请选择品种</p>
					</view>
					<view class="search-box">
						<view>
							<van-search placeholder="请输入品种名字" v-model="searchValue" label="面料搜索：" background="#ffffff"
								@input="searchTo()" :clearable="false" />
						</view>
						<view class="flex-btn">
							<button class="search-btn" @click="upSearch()">↑</button>
							<button class="search-btn" @click="downSearch()">↓</button>
						</view>
					</view>
				</view>
			</view>
		</view>
	</van-popup>

	<van-calendar v-model:show="show" @confirm="onConfirmDate" :min-date="new Date(2010, 0, 1)"
		:max-date="new Date(2050, 0, 31)" />
</template>

<style lang="scss" scoped>
	.flex {
		display: flex;
		flex-direction: column;
		height: 100vh;
		width: 100vw;
		overflow-y: hidden;

		.van-nav-bar {
			width: 100%;
		}

		.grid-container {
			display: grid;
			grid-template-columns: 2fr 3fr 1.3fr 1.5fr;
			padding: 0 15rpx;

			.grid-item {
				border: 1px solid #f2f2f2;
				display: flex;
				align-items: center;
				text-align: center;
				justify-content: center;
				padding: 5rpx;

				.grid-container1 {
					display: grid;
					grid-template-columns: 1fr;
					width: 100%;
					height: 100%;

					.grid-item2 {
						display: flex;
						align-items: center;
						text-align: center;
						justify-content: center;
						padding: 5rpx;
					}

					.grid-item1 {
						border-bottom: 1px solid #f2f2f2;
						display: flex;
						align-items: center;
						text-align: center;
						justify-content: center;
						padding: 5rpx;
					}
				}
			}
		}

		.content {
			flex: 1;
			overflow-y: scroll;
		}
	}

	::v-deep .van-cell {
		padding: 5px !important;
	}

	::v-deep .van-field {
		font-size: 16px;
	}

	.bor {
		::v-deep .van-field__control {
			border: 1px solid #d7d7d7;
			text-align: center;
		}

		::v-deep .van-field__label {
			margin: 0;
		}
	}

	.bor-a {
		::v-deep .van-field__control {
			border-bottom: 1px solid #d7d7d7;
			text-align: center;
		}

		::v-deep .van-field__label {
			margin: 0;
		}
	}

	::v-deep .van-button--normal {
		padding: 5px 8px;
		height: 30px;
	}

	::v-deep .van-field__control {
		text-align: center;
		font-size: 16px;
	}

	/*面料选择搜索框*/
	.select-model {
		position: relative;
	}

	.confirm-select {
		width: 100%;
	}

	.confirm-select>p {
		text-align: center;
	}

	.confirm-select>button {
		border: none;
		background-color: #ffffff;
		color: #388aed;
		margin: 10px 30px 0 0;
	}

	.top-select {
		position: absolute;
		top: 30px;
		left: 0;
		right: 0;
		margin: auto;
		z-index: 999;
	}

	::v-deep .select-model .van-picker__toolbar {
		height: 66px;
		align-items: flex-start;
		/*justify-content: flex-end;*/
	}

	::v-deep .select-model .van-picker__cancel,
	.select-model .van-picker__confirm {
		height: 30px;
		padding: 10px 16px 0;
	}

	.search-btn {
		padding: 1px 8px;
		border: none;
		background-color: #388aed;
		color: #ffffff;
		margin-left: 5px;
		height: 30px;
		line-height: 25px;
	}

	.search-box {
		display: flex;
		flex-direction: row;
		align-items: center;
		justify-content: center;
		padding-top: 15px;
		padding-bottom: 5px;
		position: relative;
		background-color: #fff;
	}

	.van-search {
		background-color: #f7f7f8;
	}

	.ml-search-jump {
		padding: 3px 10px;
		background-color: #388aed;
		color: #ffffff;
		border: none;
		margin-left: 10px;
	}

	.flex-btn {
		display: flex;
		flex-direction: row;
		align-items: center;
		justify-content: space-between;
	}
</style>